import * as mc from '@minecraft/server'
import * as ui from '@minecraft/server-ui'
var warped = []
const itemm = {}
function setObj(obj, val) {
    if (getObj(obj)) {
        delObj(obj)
        mc.world.scoreboard.addObjective(obj,val)
    } else {
        mc.world.scoreboard.addObjective(obj,val)
    }
}
function getObj(obj) {
    if (mc.world.scoreboard.getObjective(`${obj}`)) {
        return mc.world.scoreboard.getObjective(`${obj}`).displayName
    }
}
mc.Player.prototype.rca = function(cmd){
    this.runCommandAsync(cmd)
}
function delObj(obj) {
    if (getObj(obj)) {
    mc.world.scoreboard.removeObjective(obj)
    } else {
        return undefined
    }
}

mc.world.events.beforeChat.subscribe(chat => {
    var {message: msg,sender:player} = chat
    var [cmd , subcmd] = msg.split(/\s+/g)
    if (cmd == "!reset") {
        chat.cancel = true;
        mc.world.scoreboard.getObjectives().forEach(obj => {
            if (obj.id.startsWith("warp")) {
                var cords = getObj(obj.id)
                var nameId = getObj(cords)
                var name = getObj(nameId)
                delObj(obj.id)
                delObj(cords)
                delObj(nameId)
                delObj(name)
                setObj("sn","0")
                player.tell(`§eDeleting "§g${name}§e"......`)
                player.tell(`§6Successfully Deleted Warp: "§e${name}§6" .`)
            }
        })
    } else if (cmd == "!clr") {
        mc.world.scoreboard.getObjectives().forEach(obj => {
            delObj(obj.id)
        })
    } else if (cmd == "!warps") {
        chat.cancel = true
        var subcmd = subcmd? subcmd: "0_0_0"
        var [x,y,z] = subcmd.split("__")
        form2(player,x,y,z)
        player.tell(`§e${player.name} §cPlease close your chat instantly.....`)
    } else if (cmd == "!it") {
        chat.cancel = true
        var inv = player.getComponent('inventory').container;
  var item = inv.getItem(player.selectedSlot);
        player.tell(`${item.typeId}`)
        for (let x in item) {
            player.tell(`${x}: ${item[x]}`)
        }
        var text = ""
        while (true) {
  const result = mc.ItemTypes.getAll().next();
  if (result.done) break;
  text += result.value + "\n";
        player.tell(text)
        }
    }
})
mc.world.events.itemUseOn.subscribe(evd => {
    var {
        blockLocation, source: player
    } = evd
    var {
        x, y, z
    } = blockLocation
    var block = player.dimension.getBlock(new mc.BlockLocation(blockLocation.x, blockLocation.y, blockLocation.z))
    if (block.typeId == "warp:block" && player.isSneaking == false) {
        if (getObj(`${block.location.x}_${block.location.y}_${block.location.z}`)) {
            form2(player, x, y, z)
        } else {
            form(player, block)
        }
    } else if (block.typeId == "warp:block" && player.isSneaking == true) {
        rform(player, x, y, z,evd.item)
    }
})
function form(player, block) {
    new ui.ModalFormData().textField("Enter Block Name Here",
        `Enter Block Name Here. For Ex: \n§e${player.name}'s Home`).show(player).then(res => {
            var name = res.formValues[0]
            if (name == "") { player.tell("§cName Cannot Be Empty"); return;
            }
            if (getObj(`${name}`)) {
                player.tell(`"§e${name}§r"§c Name Is Already Occupied. Rather Choose Other`)
            } else {
                var num = ng()
                setObj(`warp${num}`, `${block.location.x}_${block.location.y}_${block.location.z}`)
                setObj(`${block.location.x}_${block.location.y}_${block.location.z}`, `Nwarp${num}`)
                setObj(`Nwarp${num}`, name)
                setObj(`${name}`, player.dimension.id)
                player.tell(`§5Saved Warp Block With Name "§e${name}§5"`)
            }
        })
}
function ng() {
    if (getObj("sn")) {
        var num = Number(getObj("sn"))
        setObj("sn", String(num + 1))
        return getObj("sn")
    } else {
        setObj("sn", "0")
        return "0"
    }
}
function form2(player, x, y, z) {
    var name = getObj(getObj(`${x}_${y}_${z}`))?getObj(getObj(`${x}_${y}_${z}`)): "Warps Menu"
    var warped = mc.world.scoreboard.getObjectives().filter(obj => {
        if (obj.id.startsWith("warp")) {
            return obj
        }
    })
    var warpsCord = warped.map(obj => {
        return obj.displayName
    })
    var warpsName = warped.map(obj => {
        return getObj(getObj(getObj(obj.id)))
    })
    var warpsDimension = warped.map(obj => {
        return getObj(getObj(getObj(getObj(obj.id))))
    })
    var form = new ui.ActionFormData()
    form.title("Warp Method")
    form.body(`Welcome To §e${name}\n§rSelect A Name To Warp`)
    for (var i = 0; i < warpsName.length; i++) {
        form.button(`Warp To ${warpsName[i]}\n Dimension: §e${warpsDimension[i].replace("minecraft:", "").toUpperCase()}`)
    }
    var source = player
    forceUi(form,player).then(res => {
        var ind = res.selection
        var cord = warpsCord[ind]
        var dimension = mc.world.getDimension(warpsDimension[ind])
        var [x1, y1, z1] = cord.split("_")
        var x2 = Number(x1)
        var y2 = Number(y1)
        var z2 = Number(z1)
        var vector = new mc.Vector(x2 + 0.5, (y2 + 1), z2 + 0.5)
        var vector2 = new mc.Vector(x2 + 0.5, y2 - 1, z2 + 0.5)
        source.teleportFacing(vector, dimension, vector2)
        source.tell(`Successfully Warped To §e${warpsName[ind]}`)
    })
}
function rform(player, x, y, z,item) {
    var n1 = getObj(`${x}_${y}_${z}`)
    var name = getObj(`${n1}`)? getObj(`${n1}`): "Warp Block"
    new ui.MessageFormData().title(`Remove ${name}`).body("Are you sure you want to remove this block? \n You Can Place It Again With The Same Name").button1(`No (Cancel)`).button2(`Yes (Remove ${name})`).show(player).then(res => {
        if (res.selection == 0) {
            var nameId = getObj(`${x}_${y}_${z}`)
            var cords = `${x}_${y}_${z}`
            var num = Number(getObj("sn"))
            var blockId = nameId?.replace("N", "")
            delObj(name)
            delObj(cords)
            delObj(nameId)
            delObj(blockId)
            setObj("sn", String(num - 1))
            player.dimension.runCommandAsync(`setblock ${x} ${y} ${z} air`)
            player.getComponent("inventory").container.addItem(new mc.ItemStack(mc.ItemTypes.get("warp:block"),1,0))
            player.tell(`Successfully Removed Warp: §e${name}`)
        }
    })
}
mc.world.events.blockBreak.subscribe(ev => {
    var {block,player} = ev
    var {x,y,z} = block.location
    if (getObj(`${x}_${y}_${z}`)) {
        var n1 = getObj(`${x}_${y}_${z}`)
        var name = getObj(`${n1}`)? getObj(`${n1}`): "Warp Block"
        var nameId = getObj(`${x}_${y}_${z}`)
        var cords = `${x}_${y}_${z}`
        var num = Number(getObj("sn"))
        var blockId = nameId.replace("N", "")
        delObj(name)
        delObj(cords)
        delObj(nameId)
        delObj(blockId)
        setObj("sn", String(num - 1))
        player.tell(`Successfully Removed Warp: §e${name}`)
    }
})
function forceUi( form, player, timeout = 20 * 5 ) {

    return new Promise( async (resolve, reject) => {

        mc.system.run(async function run() {
            let response
            
            try {
                response = await form.show( player )
            } catch (error) {
                reject( error )
                return
            }
            
            const { 
                canceled,
                cancelationReason 
            } = response
            
            if (canceled && cancelationReason == ui.FormCancelationReason.userBusy) {
                timeout-- && mc.system.run( run )
                return
            }
            
            resolve( response )
            
        })
            
    })
}